<template>
  <div id="home">
    <div class="p-grid p-p-6">
      <div class="background p-col-5 p-text-center p-grid p-jc-center p-ai-center vertical-container p-m-6">
        <div class="p-col-8">
          <p v-t="'home.title'" class="heading"/>
          <p v-t="'home.subtitle'" class="p-pb-4"/>
          <Button :label="$t('home.catalogButton')" class="p-button-rounded p-text-bold"/>
        </div>
      </div>
    </div>
    <div class="best-sale p-p-3 p-text-center p-mb-1 p-mt-3">
      <template v-if="loading">
        <ProgressSpinner/>
      </template>
      <template v-else>
        <template v-if="!products.length">
          <p v-t="'home.noProducts'"/>
        </template>
        <Carousel v-else :autoplay-interval="5000" :circular="true" :num-scroll="1" :num-visible="5"
                  :responsive-options="responsiveOptions"
                  :value="products">
          <template #item="slotProps">
            <div class="product-item p-mb-3">
              <div class="p-mb-3 p-grid p-jc-center image">
                <ImagePreloaded :alt="slotProps.data.name" :placeholder="slotProps.data.preview"
                                :src="slotProps.data.image"
                                class="product-image p-col-10"/>
              </div>
              <div>
                <h4 class="p-mb-1">{{ slotProps.data.name }}</h4>
                <h6 class="p-mt-0 p-mb-3 price">
                  <a :class="{'discounted': getDiscount(slotProps.data)}">
                    {{ slotProps.data.price }}
                  </a>
                  <a v-if="getDiscount(slotProps.data)" class="p-ml-1">
                    {{ getDiscount(slotProps.data) }}
                  </a>
                  <i class="far fa-ruble-sign p-ml-1"/>
                </h6>
                <div class="cart-buttons p-mt-3">
                  <Button :label="$t('home.productsButton')" class="p-button-help"/>
                </div>
              </div>
            </div>
          </template>
        </Carousel>
      </template>
    </div>
    <div class="about p-grid">
      <div class="p-col-6 p-grid p-jc-center p-ai-center p-m-0">
        <div class="p-col-8 p-text-center">
          <h2 v-t="'home.about.title'" class="heading"/>
          <p v-t="'home.about.content'"/>
          <Button :label="$t('home.about.button')" class="p-button-info p-button-rounded"/>
        </div>
      </div>
      <div class="p-col-6"/>
    </div>
    <div class="contacts p-grid p-mt-0">
      <div class="p-col-6"/>
      <div class="p-col-6  p-grid p-jc-center p-ai-center p-m-0">
        <div class="p-col-8 p-text-center">
          <h2 v-t="'home.contacts.title'" class="heading"/>
          <div>
            <Button class="p-button-text p-button-secondary p-button-link" icon="fab fa-vk" @click="to('vk')"/>
            <Button class="p-button-text p-button-secondary p-button-link p-mx-2" icon="fab fa-instagram"
                    @click="to('instagram')"/>
            <Button class="p-button-text p-button-secondary p-button-link" icon="fab fa-tiktok" @click="to('tiktok')"/>
          </div>
          <div>
            <span class="p-float-label p-mt-5">
              <InputText id="name" v-model="name" type="text"/>
              <label v-t="'home.contacts.form.name'" for="name"/>
            </span>
            <span class="p-float-label p-mt-5">
              <InputText id="email" v-model="email" type="text"/>
              <label v-t="'home.contacts.form.email'" for="email"/>
            </span>
            <span class="p-float-label p-mt-5">
              <Textarea id="message" v-model="message"/>
              <label v-t="'home.contacts.form.message'" for="message"/>
            </span>
            <i18n-t keypath="recaptcha.warning" tag="p" class="p-mt-2">
              <template #privacy>
                <a v-t="'recaptcha.privacy'" href="https://policies.google.com/privacy"
                   rel="nofollow noreferrer external noopener"/>
              </template>
              <template #terms>
                <a v-t="'recaptcha.terms'" href="https://policies.google.com/terms"
                   rel="nofollow noreferrer external noopener"/>
              </template>
            </i18n-t>
            <i18n-t keypath="legal.privacy.warning" tag="p">
              <template #link>
                <router-link v-t="'legal.privacy.link'" to="/"/>
              </template>
            </i18n-t>
            <Button :label="$t('home.contacts.form.submit')" class="p-mt-1" @click="submitFeedback"/>
          </div>
        </div>
      </div>
    </div>
  </div>
  <Toast position="top-right"/>
</template>

<script>
import { defineAsyncComponent } from 'vue';

export default {
  name: 'Home',
  components: {
    Button: defineAsyncComponent(() => import(/* webpackChunkName: "primevue/button", webpackPreload: true */ 'primevue/button')),
    Carousel: defineAsyncComponent(() => import(/* webpackChunkName: "primevue/carousel", webpackPreload: true */ 'primevue/carousel')),
    ProgressSpinner: defineAsyncComponent(
        () => import(/* webpackChunkName: "primevue/progressspinner", webpackPreload: true */ 'primevue/progressspinner')),
    ImagePreloaded: defineAsyncComponent(
        () => import(/* webpackChunkName: "imagePreloaded", webpackPreload: true */ '@/components/imagePreloaded')),
    InputText: defineAsyncComponent(() => import(/* webpackChunkName: "primevue/inputtext", webpackPreload: true */ 'primevue/inputtext')),
    Textarea: defineAsyncComponent(() => import(/* webpackChunkName: "primevue/textarea", webpackPreload: true */ 'primevue/textarea')),
    Toast: defineAsyncComponent(() => import(/* webpackChunkName: "primevue/toast", webpackPreload: true */ 'primevue/toast')),
  },
  inject: ['recaptcha'],
  data() {
    return {
      products: [],
      loading: true,
      responsiveOptions: [
        {
          breakpoint: '1024px',
          numVisible: 3,
          numScroll: 3,
        },
        {
          breakpoint: '600px',
          numVisible: 2,
          numScroll: 2,
        },
        {
          breakpoint: '480px',
          numVisible: 1,
          numScroll: 1,
        },
      ],
      email: null,
      name: null,
      message: null,
      social: {
        vk: 'https://vk.com/muavr',
        instagram: 'https://www.instagram.com/muavr_nsk',
        tiktok: 'https://www.tiktok.com/@muavr',
      },
    };
  },
  async mounted() {
    try {
      this.products = await this.$store.dispatch('shop/getBestSales');
    } finally {
      this.loading = false;
    }
  },
  methods: {
    async submitFeedback() {
      this.$toast.add({severity:'success', summary: 'Success Message', detail:'Order submitted', life: 3000});
      console.log(await this.recaptcha());
    },
    to(dest) {
      if (!Object.prototype.hasOwnProperty.call(this.social, dest)) {
        return;
      }

      window.open(this.social[dest], '_blank')
          .focus();
    },
    getDiscount(product) {
      if (typeof product.discount !== 'object' || !product.discount ||
          !Object.prototype.hasOwnProperty.call(product.discount, 'type') ||
          !Object.prototype.hasOwnProperty.call(product.discount, 'amount')) {
        return null;
      }

      switch (product.discount.type) {
        case 'fixed':
          return product.price - product.discount.amount;
        case 'percentage':
          return Math.max(product.price * ((100 - product.discount.amount) / 100), 0);
        default:
          return null;
      }
    },
  },
};
</script>

<style lang="scss" scoped>
#home {
  > div:first-of-type {
    background:      url('~@/assets/images/man_texting.png') no-repeat;
    background-size: cover;
  }
}

.background {
  background: rgba(0, 0, 0, .3);
  height:     68vh;

  > div {
    font-size: 20pt;
  }

  .heading {
    color:     $primaryColor;
    font-size: 60pt;
  }
}

.best-sale {
  background: $bodyBg;

  > p {
    font-size: 30pt;
  }

  .image {
    height:   30vh;
    overflow: hidden;
  }

  .price {
    color: $primaryColor;

    a {
      color: $primaryColor;
    }

    .fa-ruble-sign {
      font-size: 9pt;
    }

    .discounted {
      text-decoration:       line-through;
      text-decoration-color: $dangerButtonBg;
    }
  }
}

.about {
  height: 80vh;

  > div {
    background: $primaryColor;
    overflow:   hidden;

    &:last-of-type {
      background:      url('~@/assets/images/printing.jpg') center center;
      background-size: 155%;
    }

    .heading {
      font-size: 40pt;
    }

    p {
      font-size: 13pt;
    }
  }
}

.contacts {
  height: 80vh;

  > div {
    background: none;
    overflow:   hidden;

    &:first-of-type {
      background:      url('~@/assets/images/couple.jpg') center center;
      background-size: 145%;
    }

    .heading {
      color:     $primaryColor;
      font-size: 40pt;
    }

    input, textarea {
      resize: none;
      width:  100%;
    }

    textarea {
      height: 25vh;
    }
  }
}
</style>
